#include <reg52.h>
#include <intrins.h>

typedef unsigned char uchar;
typedef unsigned char uint;
//****************************************IO˿ڶ***************************************
sbit 	MISO	=P1^2;
sbit 	MOSI	=P3^2;
sbit	SCK	    =P1^6;
sbit	CE	    =P1^5;
sbit	CSN		=P1^7;
sbit	IRQ		=P1^3;
//***********************************0-9*******************************************
uchar seg[10]={0xC0,0xCF,0xA4,0xB0,0x99,0x92,0x82,0xF8,0x80,0x90};         //0~~9
uchar TxBuf[32]=
{
0x01,0x02,0x03,0x4,0x05,0x06,0x07,0x08,
0x09,0x10,0x11,0x12,0x13,0x14,0x15,0x16,
0x17,0x18,0x19,0x20,0x21,0x22,0x23,0x24,
0x25,0x26,0x27,0x28,0x29,0x30,0x31,0x32,
};	 // 
//**********************************************************************************
sbit	KEY1=P3^6;
sbit	KEY2=P3^7;
//***********************************λѡ**************************************************
sbit	led1=P2^1;
sbit	led0=P2^0;
sbit	led2=P2^2;
sbit	led3=P2^3;
//*********************************************NRF24L01*************************************
#define TX_ADR_WIDTH    5   	// 5 uints TX address width
#define RX_ADR_WIDTH    5   	// 5 uints RX address width
#define TX_PLOAD_WIDTH  32  	// 20 uints TX payload
#define RX_PLOAD_WIDTH  32  	// 20 uints TX payload
uint const TX_ADDRESS[TX_ADR_WIDTH]= {0x34,0x43,0x10,0x10,0x01};	//صַ
uint const RX_ADDRESS[RX_ADR_WIDTH]= {0x34,0x43,0x10,0x10,0x01};	//յַ
//***************************************NRF24L01Ĵָ*******************************************************
#define READ_REG        0x00  	// Ĵָ
#define WRITE_REG       0x20 	// дĴָ
#define RD_RX_PLOAD     0x61  	// ȡָ
#define WR_TX_PLOAD     0xA0  	// дָ
#define FLUSH_TX        0xE1 	// ϴ FIFOָ
#define FLUSH_RX        0xE2  	// ϴ FIFOָ
#define REUSE_TX_PL     0xE3  	// ظװָ
#define NOP             0xFF  	// 
//*************************************SPI(nRF24L01)Ĵַ****************************************************
#define CONFIG          0x00  // շ״̬CRCУģʽԼշ״̬Ӧʽ
#define EN_AA           0x01  // ԶӦ
#define EN_RXADDR       0x02  // ŵ
#define SETUP_AW        0x03  // շַ
#define SETUP_RETR      0x04  // Զط
#define RF_CH           0x05  // Ƶ
#define RF_SETUP        0x06  // ʡĹ
#define STATUS          0x07  // ״̬Ĵ
#define OBSERVE_TX      0x08  // ͼ⹦
#define CD              0x09  // ַ           
#define RX_ADDR_P0      0x0A  // Ƶ0ݵַ
#define RX_ADDR_P1      0x0B  // Ƶ1ݵַ
#define RX_ADDR_P2      0x0C  // Ƶ2ݵַ
#define RX_ADDR_P3      0x0D  // Ƶ3ݵַ
#define RX_ADDR_P4      0x0E  // Ƶ4ݵַ
#define RX_ADDR_P5      0x0F  // Ƶ5ݵַ
#define TX_ADDR         0x10  // ͵ַĴ
#define RX_PW_P0        0x11  // Ƶ0ݳ
#define RX_PW_P1        0x12  // Ƶ0ݳ
#define RX_PW_P2        0x13  // Ƶ0ݳ
#define RX_PW_P3        0x14  // Ƶ0ݳ
#define RX_PW_P4        0x15  // Ƶ0ݳ
#define RX_PW_P5        0x16  // Ƶ0ݳ
#define FIFO_STATUS     0x17  // FIFOջջ״̬Ĵ
//**************************************************************************************
void Delay(unsigned int s);
void inerDelay_us(unsigned char n);
void init_NRF24L01(void);
uint SPI_RW(uint uchar);
uchar SPI_Read(uchar reg);
void SetRX_Mode(void);
uint SPI_RW_Reg(uchar reg, uchar value);
uint SPI_Read_Buf(uchar reg, uchar *pBuf, uchar uchars);
uint SPI_Write_Buf(uchar reg, uchar *pBuf, uchar uchars);
unsigned char nRF24L01_RxPacket(unsigned char* rx_buf);
void nRF24L01_TxPacket(unsigned char * tx_buf);
//*****************************************ʱ*****************************************
void Delay(unsigned int s)
{
	unsigned int i;
	for(i=0; i<s; i++);
	for(i=0; i<s; i++);
}
//******************************************************************************************
uint 	bdata sta;   //״̬־
sbit	RX_DR	=sta^6;
sbit	TX_DS	=sta^5;
sbit	MAX_RT	=sta^4;
/******************************************************************************************
/*ʱ
/******************************************************************************************/
void inerDelay_us(unsigned char n)
{
	for(;n>0;n--)
		_nop_();
}
//****************************************************************************************
/*NRF24L01ʼ
//***************************************************************************************/
void init_NRF24L01(void)
{
    inerDelay_us(100);
 	CE=0;    // chip enable
 	CSN=1;   // Spi disable 
 	SCK=0;   // Spi clock line init high
	SPI_Write_Buf(WRITE_REG + TX_ADDR, TX_ADDRESS, TX_ADR_WIDTH);    // дصַ	
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, RX_ADDRESS, RX_ADR_WIDTH); // дն˵ַ
	SPI_RW_Reg(WRITE_REG + EN_AA, 0x01);      //  Ƶ0Զ	ACKӦ	
	SPI_RW_Reg(WRITE_REG + EN_RXADDR, 0x01);  //  յַֻƵ0ҪƵԲοPage21  
	SPI_RW_Reg(WRITE_REG + RF_CH, 0);        //   ŵΪ2.4GHZշһ
	SPI_RW_Reg(WRITE_REG + RX_PW_P0, RX_PLOAD_WIDTH); //ýݳȣΪ32ֽ
	SPI_RW_Reg(WRITE_REG + RF_SETUP, 0x07);   		//÷Ϊ1MHZ书Ϊֵ0dB	
	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0e);   		 // IRQշжӦ16λCRC

}
/****************************************************************************************************
/*uint SPI_RW(uint uchar)
/*ܣNRF24L01SPIдʱ
/****************************************************************************************************/
uint SPI_RW(uint uchar)
{
	uint bit_ctr;
   	for(bit_ctr=0;bit_ctr<8;bit_ctr++) // output 8-bit
   	{
		MOSI = (uchar & 0x80);         // output 'uchar', MSB to MOSI
		uchar = (uchar << 1);           // shift next bit into MSB..
		SCK = 1;                      // Set SCK high..
		uchar |= MISO;       		  // capture current MISO bit
		SCK = 0;            		  // ..then set SCK low again
   	}
    return(uchar);           		  // return read uchar
}
/****************************************************************************************************
/*uchar SPI_Read(uchar reg)
/*ܣNRF24L01SPIʱ
/****************************************************************************************************/
uchar SPI_Read(uchar reg)
{
	uchar reg_val;
	
	CSN = 0;                // CSN low, initialize SPI communication...
	SPI_RW(reg);            // Select register to read from..
	reg_val = SPI_RW(0);    // ..then read registervalue
	CSN = 1;                // CSN high, terminate SPI communication
	
	return(reg_val);        // return register value
}
/****************************************************************************************************/
/*ܣNRF24L01дĴ
/****************************************************************************************************/
uint SPI_RW_Reg(uchar reg, uchar value)
{
	uint status;
	
	CSN = 0;                   // CSN low, init SPI transaction
	status = SPI_RW(reg);      // select register
	SPI_RW(value);             // ..and write value to it..
	CSN = 1;                   // CSN high again
	
	return(status);            // return nRF24L01 status uchar
}
/****************************************************************************************************/
/*uint SPI_Read_Buf(uchar reg, uchar *pBuf, uchar uchars)
/*: ڶݣregΪĴַpBufΪݵַucharsݵĸ
/****************************************************************************************************/
uint SPI_Read_Buf(uchar reg, uchar *pBuf, uchar uchars)
{
	uint status,uchar_ctr;
	
	CSN = 0;                    		// Set CSN low, init SPI tranaction
	status = SPI_RW(reg);       		// Select register to write to and read status uchar
	
	for(uchar_ctr=0;uchar_ctr<uchars;uchar_ctr++)
		pBuf[uchar_ctr] = SPI_RW(0);    // 
	
	CSN = 1;                           
	
	return(status);                    // return nRF24L01 status uchar
}
/*********************************************************************************************************
/*uint SPI_Write_Buf(uchar reg, uchar *pBuf, uchar uchars)
/*: дݣΪĴַpBufΪдݵַucharsдݵĸ
/*********************************************************************************************************/
uint SPI_Write_Buf(uchar reg, uchar *pBuf, uchar uchars)
{
	uint status,uchar_ctr;
	
	CSN = 0;            //SPIʹ       
	status = SPI_RW(reg);   
	for(uchar_ctr=0; uchar_ctr<uchars; uchar_ctr++) //
		SPI_RW(*pBuf++);
	CSN = 1;           //رSPI
	return(status);    // 
}
/****************************************************************************************************/
/*void SetRX_Mode(void)
/*ܣݽ 
/****************************************************************************************************/
void SetRX_Mode(void)
{
	CE=0;
	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0f);   		// IRQշжӦ16λCRC	
	CE = 1; 
	inerDelay_us(130);
}
/******************************************************************************************************/
/*unsigned char nRF24L01_RxPacket(unsigned char* rx_buf)
/*ܣݶȡrx_bufջ
/******************************************************************************************************/
unsigned char nRF24L01_RxPacket(unsigned char* rx_buf)
{
    unsigned char revale=0;
	sta=SPI_Read(STATUS);	// ȡ״̬Ĵжݽ״
	if(RX_DR)				// жǷյ
	{
	    CE = 0; 			//SPIʹ
		SPI_Read_Buf(RD_RX_PLOAD,rx_buf,TX_PLOAD_WIDTH);// read receive payload from RX_FIFO buffer
		revale =1;			//ȡɱ־
	}
	SPI_RW_Reg(WRITE_REG+STATUS,sta);   //յݺRX_DR,TX_DS,MAX_PTøΪ1ͨд1жϱ־
	return revale;
}
/***********************************************************************************************************
/*void nRF24L01_TxPacket(unsigned char * tx_buf)
/*ܣ tx_buf
/**********************************************************************************************************/
void nRF24L01_TxPacket(unsigned char * tx_buf)
{
	CE=0;			//StandBy Iģʽ	
	SPI_Write_Buf(WRITE_REG + RX_ADDR_P0, TX_ADDRESS, TX_ADR_WIDTH); // װؽն˵ַ
	SPI_Write_Buf(WR_TX_PLOAD, tx_buf, TX_PLOAD_WIDTH); 			 // װ	
//	SPI_RW_Reg(WRITE_REG + CONFIG, 0x0e);   		 // IRQշжӦ16λCRC
	CE=1;		 //øCEݷ
	inerDelay_us(10);
}
//************************************************************************************************
void main(void)
{
	uchar temp =0;	
    init_NRF24L01() ;
	led0=0;led1=0;led2=0;led3=0;
	P0=0x00;
	nRF24L01_TxPacket(TxBuf);	// Transmit Tx buffer data
	Delay(6000);
	P0=0xBF;
	while(1)
	{	
			if(temp<4)
		{
		switch(temp)
		{
		case 	1:	
			P0=	0xBF;
			break;	
		case 	2:	 
 	   	P0=	0xf7;
		
				break;	
		case 	3:
				P0=	0xFE;

		  	break;	
		default:  break;
		}
		}
	if(temp==3)
		{
		temp=0;
		}
		nRF24L01_TxPacket(TxBuf);	// Transmit Tx buffer data
		Delay(20000);
		SPI_RW_Reg(WRITE_REG+STATUS,0XFF);  
		temp++;
		}
	
}
